=== debian/changelog ===
minetest (5.4.1+repack-2build1) jammy; urgency=medium

  * No-change rebuild against libjsoncpp25

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 14 Dec 2021 07:49:00 +0000

minetest (5.4.1+repack-2) unstable; urgency=medium

  * Add patch to fix compilation with gcc 11 (Closes: #984238).

 -- Julien Puydt <jpuydt@debian.org>  Sun, 17 Oct 2021 23:12:21 +0200

minetest (5.4.1+repack-1) unstable; urgency=medium

  * Team upload.
  * New upstream release (Closes: #993086).
  * Refresh patches and drop now-obsolete one.
  * Mark minetest-data as Multi-Arch foreign.
  * Declare d/rules doesn't require root. 
  * Enable IPv6 server (Closes: #987104).
  * Bump standards-version to 4.6.0.
  * Use fonts from the fonts-croscore package as much as possible.
  * Bump d/watch to version 4.
  * Drop WTFPL license from d/copyright (unused).
  * Add patch to fix some typos.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 18 Sep 2021 17:10:00 +0200
