=== debian/changelog ===
minetest (5.5.0+dfsg+~1.9.0mt4+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Add git-buildpackage config file.
  * Migrate from repack.sh to Files-Excluded.
  * Refresh patches.
  * Add NEWS describing breaking/significant changes.
  * Add README.source for maintainer notes.

 -- Travis Wrightsman <travis@wrightsman.org>  Sun, 27 Feb 2022 17:10:55 -0500
