=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: minetest
 Section: games
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
  Martin Quinson <mquinson@debian.org>,
  Markus Koschany <apo@debian.org>,
@@ -16,7 +15,6 @@
  libfreetype6-dev,
  libglu1-mesa-dev,
  libgmp-dev,
- libirrlicht-dev (>= 1.7.0),
  libjpeg-dev,
  libjsoncpp-dev,
  libleveldb-dev,
@@ -31,7 +29,13 @@
  libx11-dev,
  libxxf86vm-dev,
  postgresql-server-dev-all,
- zlib1g-dev
+ zlib1g-dev,
+ libsdl2-dev,
+ doxygen,
+ libxrandr-dev,
+ mesa-common-dev (>= 7.6),
+ x11proto-xf86vidmode-dev,
+ libzstd-dev
 Standards-Version: 4.6.0
 Homepage: https://www.minetest.net/
 Vcs-Git: https://salsa.debian.org/games-team/minetest.git
