## minetest 5.6.1%2Bdfsg%2B~1.9.0mt8%2Bdfsg

=== src/benchmark/CMakeLists.txt ===
set (BENCHMARK_SRCS
	${CMAKE_CURRENT_SOURCE_DIR}/benchmark.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/benchmark_serialize.cpp
	PARENT_SCOPE)

set (BENCHMARK_CLIENT_SRCS
	PARENT_SCOPE)
