=== debian/tests/control ===
Tests: minetest-unittests
Depends: minetest
Restrictions: allow-stderr
